/*	Unused table for psencode, I planned to detect named
	constants and turn them into integers.  This may be
	dangerous: it is not strictly compatable if the user redefines
	any of the names.  Perhaps a warning message if one of these
	names is given as a literal (/foo) would do it?

	This file was created by executing this code:

	/buf 100 string def
	nextdict {dup type /integertype eq
        {exch buf cvs (") print print (", ) print buf cvs print (,) =}
	{pop pop} ifelse} forall

	The output was then sorted, and non-constants produced by
	the windowPackage.ps code were edited out of the result.
*/

typedef struct {const char *name,int value} constant;
const constant constants[] = {},
	{"Above", 1},
	{"Allevents", -1},
	{"Alphashiftmask", 65536},
	{"Alternatemask", 524288},
	{"AppAct", 1, /* from windowPackage.ps */},
	{"AppDeact", 2, /* from windowPackage.ps */},
	{"AppUnhide", 7, /* from windowPackage.ps */},
	{"Appdefined", 15},
	{"Appdefinedmask", 32768},
	{"Asciiset", 0},
	{"Below", -1},
	{"Broadcast", 1},
	{"Buffered", 2},
	{"Bypscontext", 11},
	{"Bytype", 0},
	/* "CDPid", 0, */ /* from windowPackage.ps */
	/* "CDToken", 1, */ /* from windowPackage.ps */
	{"Clear", 0},
	{"Commandmask", 1048576},
	{"Controlmask", 262144},
	{"Copy", 1},
	{"Cursorrect", 17, /* event from windowPackage.ps */},
	{"Cursorrectmask", 131072, /* from windowPackage.ps */},
	{"Data", 1},
	{"Datop", 9},
	{"Din", 7},
	{"Dingbatsset", 2},
	{"Dout", 8},
	{"Dover", 6},
	{"Explicit", 9},
	{"Firstwindow", 3},
	{"Flagschanged", 12},
	{"Flagschangedmask", 4096},
	{"Highlight", 12},
	{"Journalevent", 18, /* event from windowPackage.ps */},
	{"Journaleventmask", 262144, /* from windowPackage.ps */},
	{"Journalflag", 31, /* event from windowPackage.ps */},
	{"Journalflagmask", -2147483648, /* from windowPackage.ps */},
	{"Keydown", 10},
	{"Keydownmask", 1024},
	{"Keyup", 11},
	{"Keyupmask", 2048},
	{"Kitdefined", 13},
	{"Kitdefinedmask", 8192},
	{"Lastevent", 15},
	{"Lastkey", 8},
	{"Lastleft", 6},
	{"Lastright", 7},
	{"Lmousedown", 1},
	{"Lmousedownmask", 2},
	{"Lmousedragged", 6},
	{"Lmousedraggedmask", 64},
	{"Lmouseup", 2},
	{"Lmouseupmask", 4},
	/* "MenuEvent", 152, */ /* from windowPackage.ps */
	{"MouseEvent", 254, /* from windowPackage.ps */},
	{"Mouseentered", 8},
	{"Mouseenteredmask", 256},
	{"Mouseexited", 9},
	{"Mouseexitedmask", 512},
	{"Mousemoved", 5},
	{"Mousemovedmask", 32},
	{"NX_CmykColorSpace", 5},
	{"NX_DarkGrayPattern", 1},
	{"NX_DefaultDepth", 0},
	{"NX_EightBitGray", 264},
	{"NX_LightGrayPattern", 3},
	{"NX_MediumGrayPattern", 2},
	{"NX_OneIsBlackColorSpace", 0},
	{"NX_OneIsWhiteColorSpace", 1},
	{"NX_RgbColorSpace", 2},
	{"NX_TwelveBitRGB", 516},
	{"NX_TwentyFourBitRGB", 520},
	{"NX_TwoBitGray", 258},
	{"Nextwindow", 5},
	{"Nonretained", 1},
	{"Nowindow", -1},
	{"Nullevent", 0},
	{"Nulleventmask", 1},
	{"Numericpadmask", 2097152},
	{"Ones", 2},
	{"Out", 0},
	{"Plus", 11},
	{"PlusD", 11},
	{"PlusL", 13},
	{"Retained", 0},
	{"Rmousedown", 3},
	{"Rmousedownmask", 8},
	{"Rmousedragged", 7},
	{"Rmousedraggedmask", 128},
	{"Rmouseup", 4},
	{"Rmouseupmask", 16},
	{"Satop", 5},
	{"Shiftmask", 131072},
	{"Sin", 3},
	{"Sout", 4},
	{"Sover", 2},
	{"Symbolset", 1},
	{"Sysdefined", 14},
	{"Sysdefinedmask", 16384},
	{"Topwindow", 2},
	{"Transmit", 10},
	{"Windragged", 0, /* from windowPackage.ps */},
	{"Winmoved", 4, /* from windowPackage.ps */},
	{"Winredraw", 0, /* from windowPackage.ps */},
	{"Winresized", 3, /* from windowPackage.ps */},
	{"Xor", 10};
/* several lower case names were here, I deleted them.
   "workspaceWindow",14 may be a constant, but NeXT will not confirm this.
*/
